<!DOCTYPE html>
<html>
  <head>
    <title>Title</title>
    <meta charset="utf-8">
    <style>
      @import url(https://fonts.googleapis.com/css?family=Yanone+Kaffeesatz);
      @import url(https://fonts.googleapis.com/css?family=Droid+Serif:400,700,400italic);
      @import url(https://fonts.googleapis.com/css?family=Ubuntu+Mono:400,700,400italic);

      body { font-family: 'Droid Serif'; }
      h1, h2, h3 {
        font-family: 'Yanone Kaffeesatz';
        font-weight: normal;
      }
      img {
            max-width:100%;
      }
      .remark-code, .remark-inline-code { font-family: 'Ubuntu Mono'; }
      .remark-slide-content {background-size: contain}
    </style>
  </head>
  <body>
    <textarea id="source">

# Hello world,
![k8s](files/images/kubernetes/k8s.png)

---
# Docker image

Let's start with a simple docker image:

    $ git clone git@0xacab.org:infrastructure/platform.git
    $ cd platform/kubernetes/hello-world/nginx-hello-world
    $ ls
    Dockerfile  index.html  README.md

    $ cat index.html
    Hello World !

    $ cat Dockerfile
    FROM nginx:alpine
    COPY --chown=nginx index.html /usr/share/nginx/html

---
# Build the image

    $ docker build -t nginx-hello-world .
    …

Show the image in your local docker registry:

    $ docker images | grep nginx-hello-world
    nginx-hello-world   latest   d485d90c479a  1 minute ago  17.7MB

---
# Run a container locally

    $ docker run --name nginx-hello-world -p 8080:80 nginx-hello-world

# Greet the world

    $ curl http://localhost:8080
    Hello World !

---
# Publish the image

i.e. on [hub.docker.com](https://hub.docker.com/):

    $ docker login

    $ docker tag nginx-hello-world varacanero/nginx-hello-world

    $ docker push varacanero/nginx-hello-world

See https://hub.docker.com/r/varacanero/nginx-hello-world/tags/ for uploaded image

---
# Install kubectl

Follow the [kubectl](https://kubernetes.io/docs/tasks/tools/install-kubectl/) installation instructions.

---
# Create namespace

    $ kubectl create namespace demo
    $ kubectl get namespace

---
# Deploy

    $ kubectl -n demo run nginx-hello-world --image=varacanero/nginx-hello-world --port=80

See what resources are created:

    $ kubectl -n demo get all

---

# Expose port

Create a service to expose the pod port (which is reachable internally only) to be reachable from outside:

    $ kubectl -n demo expose deployment nginx-hello-world --type=LoadBalancer

And lookup the exposed port:

    $ kubectl -n demo get service

---

# First Hello world !

    $ curl kubeadmin.hexacab.org:31423
    Hello World !

---

# Configure ingress

    $ cat kubernetes/hello-world/ingress.yml
    apiVersion: extensions/v1beta1
    kind: Ingress
    metadata:
      name: demo
    spec:
      rules:
      - host: demo.apps.hexacab.org
        http:
          paths:
          - path: /
            backend:
              serviceName: nginx-hello-world
              servicePort: 80

    $ kubectl -n demo create -f kubernetes/hello-world/ingress.yml

    $ curl demo.apps.hexacab.org
    Hello World !

    </textarea>
    <script src="https://remarkjs.com/downloads/remark-latest.min.js">
    </script>
    <script>
      var slideshow = remark.create();
    </script>
  </body>
</html>
